//  O3D_Cube.h
//  O3D
//
//  Created by charlie on 6/4/09.
//  Copyright 2009 One More Muse. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class O3D_Texture;
@class O3D_Vector4;
@class O3D_Quaternion;

@interface O3D_Cube : NSObject {
	O3D_Texture *tex;
	O3D_Vector4 *position;
	O3D_Quaternion *rotation;
	O3D_Quaternion *rotateBy;
	NSColor *color;
	
	float size;
}

@property (nonatomic, retain) O3D_Texture *tex;
@property (nonatomic, retain) O3D_Vector4 *position;
@property (nonatomic, retain) O3D_Quaternion *rotation, *rotateBy;
@property (nonatomic) float size;

- (id) initWithPosition:(O3D_Vector4 *)pos rotation:(O3D_Quaternion *)q texture:(O3D_Texture *)t;

- (void) draw;

@end
