//
//  O3D_Matrix.h
//  Objective3D
//
//  Created by charlie on 5/27/09.
//  Copyright 2009 One More Muse. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "O3D_Util.h"

@class O3D_Vector3;
@class O3D_Vector4;

/// 4x4 Matrix of floats
@interface O3D_Matrix : NSObject {
	/// The actual float data
	float * data;
}

@property (nonatomic) float * data;

/// Initialize with identity matrix
- (id) initWithIdentity;
/// Initialize using data from the argument
- (id) initWithMatrix:(O3D_Matrix *)matrix;
/// Initialize with a vector
- (id) initWithPositionVector4:(O3D_Vector4 *)vector;

/// Create an autoreleased matrix using a vector
+ (O3D_Matrix *) matrixWithPositionVector4:(O3D_Vector4 *)vector;

/// Multiply the receiver by the specified matrix
- (void) multiplyByMatrix:(O3D_Matrix *)matrix;
/// Multiply the matrix on the specifed axis by the specifed amount
- (void) rotateOnAxis:(O3D_Vector3 *)axis withAngle:(float)angle;
/// transpose the matrix
- (void) transpose;

@end
