//
//  O3D_Texture.h
//  Objective3D
//
//  Created by charlie on 5/29/09.
//  Copyright 2009 One More Muse. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <ApplicationServices/ApplicationServices.h>

/// Convenience class for loading and binding textures. Images are loaded using Core Image.
@interface O3D_Texture : NSObject {
	// A pointer to the location in texture memory for this texture
	GLuint texID;
}

@property (nonatomic) GLuint texID;

/// Initialize with the path to a bitmap; can be .jpg, .png, .gif etc...
- (id) initWithBitmap:(NSString *)filename;
/// Loads the bitmap; this method is called from the init and should be private
- (BOOL) loadBitmap:(NSString *)filename intoIndex:(int)texIndex;
/// Bind the texture by calling glBindTexture and passing in the textID property
- (void) bind;

@end
