//
//  O3D_Vector4.h
//  O3D
//
//  Created by charlie on 6/2/09.
//  Copyright 2009 One More Muse. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class O3D_Vector3;

@interface O3D_Vector4 : NSObject {
	float x, y, z, w;
}

@property (nonatomic) float x, y, z, w;

- (id) initWithX:(float)ax Y:(float)ay Z:(float)az W:(float)aw;
- (id) initWithVector:(id)vector;
- (id) initWithAngle:(float)angle;

+ (O3D_Vector4 *) vector;
+ (O3D_Vector4 *) vectorWithX:(float)ax Y:(float)ay Z:(float)az W:(float)aw;
+ (O3D_Vector4 *) vectorWithAngle:(float)angle;
+ (O3D_Vector4 *) vectorWithVector:(id)vector;

- (float) angle;
- (float) dotProductWithVector:(O3D_Vector4 *)vector;
- (float) angleWithVector:(O3D_Vector4 *)vector;

- (void) normalize;
- (void) rotate:(float)rotation;
- (void) asFloats:(float *)values;

- (O3D_Vector4 *) normalizedVector;
- (O3D_Vector4 *) vectorWithRotation:(float)rotation;
- (O3D_Vector3 *) vector3;




@end
